export const sequenceInfo = (selection, props) => {
  const {
    regex,
  	sequence,
    sequenceId,
    selectEvent,
    selectedEvents,
  } = props;
  
  if(!sequence) return;
  
  const fill = 'gray'
  const fontSize = '16px';
  
  const length = 20;
  
  const textSpacing = 24;
  const blockSpacing = 100;
  const numEvents = sequence.length;
  const y = (d) => 2 * spacing + (spacing * d);
  const blockSize = (i) => i * blockSpacing + 20;
  // const blockSize = spacing + (spacing * numEvents);
  
  // Create Block Groups
  const events  = selection
  	.selectAll('.blocks')
  	.data(sequence, (d) => d.data.data.id);
  const eventsEnter = events
    .enter().append('g')
      .attr('class', 'blocks')
      .attr('transform', (d,i) => `translate(4, ${blockSize(i)})`);
  events.exit().remove();
  
  
  // Draw Events
  eventsEnter.append('rect')
    .attr('y', 10)
    .attr('width', length)
    .attr('height', length)
    .attr('fill', (d) => {
  		const { id, depth } = d.data.data
      if(selectedEvents[id] && selectedEvents[id][depth] === true)
        return '#4682b4';
      if(checkRegex(regex, d.data.data))
        return '#42f462';
      return '#606060';
  	})
    .on('click', (d) => {
    	console.log(d);
    	selectEvent(d.data.data.id, d.data.data.depth);	
  	});
  
  // Draw Text
  const event = eventsEnter
  	.selectAll('text')
  	.data((d) => {
    	let { N, CN, CT } = d.data.data;
      N = N || '-';
      CN = CN || '-';
      CT = CT || '-';
      return [N, CN, CT];
    });
  const eventEnter = event
    .enter().append('text')
      .text((d) => d)
      .attr('x', length + 10)
      .attr('y', (d,i) => i * 20);
    
  
  
  // Set parent height for scrolling
  const height = selection.node().getBBox().height + 60;
  selection.attr('height', height);
}

function checkRegex(regex, data) {
  const properties = ['N', 'CN', 'CT'];
  for(let prop_i in properties) 
  {
    const prop = properties[prop_i];
    if(data.hasOwnProperty(prop) && regex) {
      if(regex.exec(data[prop])) {
        return true;
      }
    }
  }
  
  return false;
}
